import pygame, sys, random, time
from pygame.locals import *
import cPickle as P

none = 'none'

pygame.init()

#classes
class button():
	def __init__(self, pos, image, imagehighlighted, imagepressed, functionnumber, text):
		self.pos=pos
		self.image=image
		self.imagehighlighted=imagehighlighted
		self.imagepressed=imagepressed
		self.functionnumber=functionnumber
		self.pressed=False
		self.text=text
	def draw(self):
		window.blit(self.image, self.pos)
		if self.text!='none':
			text=font.render(self.text, True, (255,255,255), (0,162,232))
			textRect = text.get_rect()
			textRect.topleft = (self.pos[0]+9, self.pos[1]+9)
			window.blit(text, textRect)
			
		if self.pos.collidepoint(pygame.mouse.get_pos())==True:
			window.blit(self.imagehighlighted, self.pos)
			if self.text!='none':
				text=font.render(self.text, True, (255,255,255), (200,191,231))
				textRect = text.get_rect()
				textRect.topleft = (self.pos[0]+9, self.pos[1]+9)
				window.blit(text, textRect)
		
		if self.pressed==True:
			window.blit(self.imagepressed, self.pos)
			if self.text!='none':
				text=font.render(self.text, True, (255,255,255), (153,217,234))
				textRect = text.get_rect()
				textRect.topleft = (self.pos[0]+9, self.pos[1]+9)
				window.blit(text, textRect)
			

		
						
class menu():
	def __init__(self, pos, image, buttons):
		self.pos=pos
		self.image=image
		self.buttons=buttons
	def draw(self):
		if self.image!='none':
			window.blit(self.image, self.pos)
		for i in self.buttons:
			i.draw()
		pygame.display.update()

class piece():
	def __init__(self, lines, world):
		self.world=world
		self.coinpos=pygame.Rect(random.randint(0,10)*64,random.randint(0,10)*64,34,34)
		
		self.got_coin=False
		
		self.tiles=[]
		sublines=lines.split('>>>\n')
		y=sublines[1].split('\n')
		for i in y:
			self.tiles.append(i.split(' '))
		self.image=pygame.Surface((640,640))

		for y in range(len(self.tiles)-1):
			for x in range(len(self.tiles[y])):
				image=pygame.image.load('images/tiles/'+self.world+'/'+self.tiles[y][x]+'.png')
				image.set_colorkey((255,255,255))
				imageb = pygame.transform.scale(image, (64, 64))
				self.image.blit(imageb, (x*64, y*64, 64, 64)) 		
		
		self.objects=[]
		y=sublines[2].split('\n')
		for i in y:
			self.objects.append(i.split(' '))

		pygame.display.update()

	def draw(self, c):
		window.blit(self.image, (0,0,640,640))
	
		if self.got_coin==False and c==True:
			window.blit(coin, self.coinpos)
		
		for y in range(len(self.objects)-1):
			for x in range(len(self.objects[y])):
				pic=pygame.image.load('images/tiles/'+self.world+'/'+self.objects[y][x]+'.png')
				pic.set_colorkey((255,255,255))
				imageb = pygame.transform.scale(pic, (64, 64))
				window.blit(imageb, (x*64, y*64, 64, 64)) 	
		pygame.display.update()
		
class world():
	def __init__(self, name, coins, currentpiece):
		self.name=name
		self.coins=coins
		self.pieces=[]		
		#get pieces
		a=1
		while True:
			try:
				f=open('mappieces/'+self.name+'/'+str(a)+'.txt', 'r')
				lines=f.read()
				self.pieces.append(piece(lines, self.name))
				f.close()
			except:
				break
			a+=1
			
		

		self.currentpiece=self.pieces[currentpiece]
	def check_for_piecechange(self):
		player=main_game.player
		a=False
		if player.pos[0]>620:
			player.pos[0]-=620
			a=True
		if player.pos[0]<1:
			player.pos[0]+=620
			a=True
		if player.pos[1]>620:
			player.pos[1]-=620
			a=True
		if player.pos[1]<1:
			player.pos[1]+=620
			a=True
		
		if a==True:
			main_game.room=random.randint(0, len(self.pieces)-1)
			self.currentpiece=self.pieces[main_game.room]
			self.currentpiece.coinpos=pygame.Rect(random.randint(0,10)*64,random.randint(0,10)*64,34,34)
			self.currentpiece.got_coin=False
			#self.currentpiece.get_baddies()

class sprite():
	def __init__(self,name,life,x,y,length,width,speed):
		self.name=name
		self.life=life
		self.facing='F'	
		self.pos=pygame.Rect(x,y,width*2,width*2)
		self.length=length
		self.width=width
		self.speed=speed
		self.rect_difference=length*2-width*2
		self.image_path='images/sprites/'+self.name+'/'
		
	def walk(self, direction, frame):
		if self.life>0:
			a=0
			
			if direction=='up':
				self.pos[1]-=self.speed
				self.facing='B'
			if direction=='down':
				self.pos[1]+=self.speed
				self.facing='F'
			if direction=='left':
				self.pos[0]-=self.speed
				self.facing='L'
			if direction=='right':
				self.pos[0]+=self.speed
				self.facing='R'
				
			obstacles=main_game.world.currentpiece.objects
			
			for y in range(len(obstacles)-1):
				for x in range(len(obstacles[y])):
					if obstacles[y][x]!='00':
						rect=pygame.Rect(x*64, y*64, 64, 64)
						if self.pos.colliderect(rect)==True:
							a+=1
			
			if a>0:
				if direction=='up':
					self.pos[1]+=self.speed
				if direction=='down':
					self.pos[1]-=self.speed
				if direction=='left':
					self.pos[0]+=self.speed
				if direction=='right':
					self.pos[0]-=self.speed
					
			imagepos=pygame.Rect(self.pos[0], self.pos[1]-self.rect_difference, self.length, self.width)	
			if direction!=none:	
				image=pygame.image.load(self.image_path+self.facing+str(frame)+'.png')
			else:
				image=pygame.image.load(self.image_path+self.facing+'0'+'.png')
			image = pygame.transform.scale(image, (self.width*2, self.length*2))
			image.set_colorkey((255,255,255))
							
			window.blit(image, imagepos)
			pygame.display.update()
			
			if a>0:
				return 'bump'
			else:
				return none
				
class game():
	def __init__(self):

		self.savedgame=main_menu()
		f=file(self.savedgame+'.txt', 'r')
		a=f.read().split(',')
		f.close()

		#world,room,coins,lives,x,y		
		self.room=int(a[1])
		self.worldnumber=int(a[0])
		self.world=world(worlds[self.worldnumber],world_coins[self.worldnumber],self.room)
		self.coins=int(a[2])
		self.player=sprite('maincharacter',int(a[3]),int(a[4]),int(a[5]),40,18,6)
		self.buttondown=''
		
		self.monologues=[]
		#get monologues
		a=1
		while True:
			try:
				name='monologues/'+self.world.name+'-'+str(a)+'.txt'
				self.monologues.append(monologue(name))
			except:
				break
			a+=1
		for i in self.monologues:
			i.draw()
		
	def loop(self):
		for frame in range(4):
			#draw background
			self.world.currentpiece.draw(True)
			
			#test for events
			for event in pygame.event.get():
		 		if event.type==QUIT:
		 			quit()
		 		if event.type==KEYDOWN:
		 			for key in key_controls:
		 				if key.key==event.key:
		 					eventkey=key.output
				 			if eventkey=='escape':
				 				quit()
				 			elif eventkey=='return':
				 				pause_menu(self.savedgame)
				 			elif eventkey=='save':
				 				save(self.savedgame)
				 			else:
				 				self.buttondown=eventkey
				 	if event.key==ord('m'):
						if settings['music']==True:
							settings['music']=False
							pygame.mixer.pause()
						else:
							settings['music']=True
							pygame.mixer.unpause()
		 		
		 		if event.type==KEYUP:
		 			self.buttondown=''
		 			
		 	#gameplay
		 	if self.buttondown!='':
		 		self.player.walk(self.buttondown, frame)
		 	else:
		 		self.player.walk(none, frame)
		 		
		 	#self.player.walk('down', frame)
			for i in range(self.world.coins):
				window.blit(coinicon, (i*40+6, 6, 34, 34))
			for i in range(self.coins):
				window.blit(coin, (i*40+6, 6, 34, 34))
				
			pygame.display.update()

			
		 	draw_score(self.coins)	
		 		
		 	self.world.check_for_piecechange()

		 	#check for coin pickup
		 	if self.player.pos.colliderect(self.world.currentpiece.coinpos)==True and self.world.currentpiece.got_coin==False:
		 		self.coins+=1
		 		self.world.currentpiece.got_coin=True
		 		
		 	#check for world change
		 	if self.coins==self.world.coins:
				self.worldnumber+=1
				self.coins=0
				self.player.pos[0]=250
				self.player.pos[1]=10
				self.room=1
				if self.worldnumber>len(worlds)-1:
					credits()
		 		self.world=world(worlds[self.worldnumber],world_coins[self.worldnumber],0)
		 		
		 		self.monologues=[]
				#get monologues
				a=1
				while True:
					try:
						name='monologues/'+self.world.name+'-'+str(a)+'.txt'
						self.monologues.append(monologue(name))
					except:
						break
					a+=1
				for i in self.monologues:
					i.draw()
		 		
			mainclock.tick(10)

class key_input:
	def __init__(self, key, output):
		self.key=key
		self.output=output		

class monologue():
	def __init__(self, filename):
		f=file(filename, 'r')
		lines=f.readlines()
		f.close()
		
		self.world=world(lines[0][:-1],lines[1][:-1],0)
		self.x=int(lines[2][:-1])
		self.y=int(lines[3][:-1])
		self.lines=[]
		self.lines+=lines[4:]
		
	def draw(self):
		self.world.currentpiece.draw(False)

		image=pygame.image.load('images/sprites/maincharacter/F0.png')
		image = pygame.transform.scale(image, (36, 80))
		image.set_colorkey((255,255,255))
			
		window.blit(image, (self.x, self.y, 36, 80))
		
		pygame.draw.rect(window, (0,0,0), (0, 448, 640, 192))
		
		for i in range(len(self.lines)):
			text=font.render(self.lines[i][:-1], True, (255,255,255), (0,0,0))
			textRect = text.get_rect()
			textRect.topleft = (10, i*50+458)
			window.blit(text, textRect)	
			
		pygame.display.update()
		
		#loop
		a=True
		while a==True:
			for event in pygame.event.get():
		 		if event.type==QUIT:
		 			quit()
		 		if event.type==KEYDOWN:
		 			if event.key==K_ESCAPE:
		 				quit()
		 			if event.key==ord('m'):
						if settings['music']==True:
							settings['music']=False
							pygame.mixer.pause()
						else:
							settings['music']=True
							pygame.mixer.unpause()
		 			a=False
					
def quit():
	pygame.quit
	sys.exit()		

def instructions():
	f=file('instructions.txt', 'r')
	lines=f.readlines()
	f.close()
	
	a=True
	while a==True:
		window.fill((0,0,0))
		
		for i in range(len(lines)):
			text=font.render(lines[i][:-1], True, (255,255,255), (0,0,0))
			textRect = text.get_rect()
			textRect.topleft = (10, i*50+10)
			window.blit(text, textRect)	
			
		pygame.display.update()

		for event in pygame.event.get():
	 		if event.type==QUIT:
	 			quit()
	 		if event.type==KEYDOWN:
	 			if event.key==K_ESCAPE:
	 				quit()
	 			if event.key==ord('m'):
					if settings['music']==True:
						settings['music']=False
						pygame.mixer.pause()
					else:
						settings['music']=True
						pygame.mixer.unpause()
	 			main()	

def credits():
	f=file('credits.txt', 'r')
	lines=f.readlines()
	f.close()
	
	up=660
	
	while up>-1000:
		window.fill((0,0,0))
		
		for i in range(len(lines)):
			text=font.render(lines[i][:-1], True, (255,255,255), (0,0,0))
			textRect = text.get_rect()
			textRect.topleft = (10, i*50+up)
			window.blit(text, textRect)	
			
		pygame.display.update()
		
		up-=1
	
		mainclock.tick(50)
		
		for event in pygame.event.get():
	 		if event.type==QUIT:
	 			quit()
	 		if event.type==KEYDOWN:
	 			if event.key==K_ESCAPE:
	 				quit()
	 			if event.key==ord('m'):
					if settings['music']==True:
						settings['music']=False
						pygame.mixer.pause()
					else:
						settings['music']=True
						pygame.mixer.unpause()
	main()	
	
def save(savegame):
	f=file(savegame+'.txt', 'w')
	f.write(str(main_game.worldnumber)+','+str(main_game.room)+','+str(main_game.coins)+','+str(main_game.player.life)+','+str(main_game.player.pos[0])+','+str(main_game.player.pos[0]))
	f.close()

def pause_menu(a):
	texts=['CONTINUE', 'SAVE', 'MENU']
	buttons=[]
	for i in range(3):
		buttons.append(button(pygame.Rect(170, i*75+50, 300, 50), buttonimage, buttonhighlighted, buttonpressed, i, texts[i]))
	
	m=menu(pygame.Rect(0,0,400,640),none, buttons)
	
	#loop
	paused=True
	while paused==True:
		m.draw()
		
		for event in pygame.event.get():
	 		if event.type==QUIT:
	 			quit()
	 		if event.type==KEYDOWN:
	 			if event.key==K_ESCAPE:
	 				quit()
	 			if event.key==ord('m'):
					if settings['music']==True:
						settings['music']=False
						pygame.mixer.pause()
					else:
						settings['music']=True
						pygame.mixer.unpause()
	 		if event.type==MOUSEBUTTONDOWN:
	 			for i in m.buttons:
	 				
	 				if i.pos.collidepoint(pygame.mouse.get_pos())==True:
	 					i.pressed=True
	 					i.draw()
	 					
	 	for i in m.buttons:
	 		if i.pressed==True:
	 			if i.functionnumber==0:
	 				paused=False
	 			elif i.functionnumber==1:
	 				save(a)
	 			elif i.functionnumber==2:
	 				main()
	 			i.pressed=False
	
def draw_score(score):
	text=font.render(str(score*10), True, (255,255,255), (0,0,0))
	textRect = text.get_rect()
	textRect.topleft = (100, 10)
	window.blit(text, textRect)	

	pygame.display.update
						
def main_menu():
	w=world('menu',0,0)
	texts=['GAME 1', 'GAME 2', 'GAME 3', 'GAME 4', 'GAME 5', 'INSTRUCTIONS', 'EXIT']
	buttons=[]
	for i in range(7):
		buttons.append(button(pygame.Rect(50, i*75+50, 300, 50), buttonimage, buttonhighlighted, buttonpressed, i, texts[i]))
	
	m=menu(pygame.Rect(0,0,400,640),none, buttons)
	
	#loop
	while True:
		#draw
		w.currentpiece.draw(False)
		m.draw()
		
		for event in pygame.event.get():
	 		if event.type==QUIT:
	 			quit()
	 		if event.type==KEYDOWN:
	 			if event.key==K_ESCAPE:
	 				quit()
	 			if event.key==ord('m'):
					if settings['music']==True:
						settings['music']=False
						pygame.mixer.pause()
					else:
						settings['music']=True
						pygame.mixer.unpause()
	 		if event.type==MOUSEBUTTONDOWN:
	 			for i in m.buttons:
	 				
	 				if i.pos.collidepoint(pygame.mouse.get_pos())==True:
	 					i.pressed=True
	 					i.draw()
	 					
	 	for i in m.buttons:
	 		if i.pressed==True:
	 			if i.functionnumber==6:
	 				quit()
	 			elif i.functionnumber==5:
	 				instructions()
	 			else:
	 				return('game'+str(i.functionnumber+1))
	 			i.pressed=False
	 				
	 	mainclock.tick(10)

def heading():
	for i in range(40):
		window.fill((255,255,255))
		window.blit(title, (220,220,10,10))
		pygame.display.update()
		mainclock.tick(10)
		
		for event in pygame.event.get():
	 		if event.type==QUIT:
	 			quit()
	 		if event.type==KEYDOWN:
	 			if event.key==K_ESCAPE:
	 				quit()
	
	 	
#clock
mainclock = pygame.time.Clock()

#set up settings
settings={'screenresolution': (640,640), 'music': True, 'fullscreen': False}
key_controls=[key_input(K_UP, 'up'),key_input(K_DOWN, 'down'),key_input(K_LEFT, 'left'),key_input(K_RIGHT, 'right'),key_input(K_RETURN, 'return'),key_input(ord('s'), 'save'),key_input(K_ESCAPE, 'escape')]

#set up window
window=pygame.display.set_mode(settings['screenresolution'])
pygame.display.set_caption('Backyard labyrinth')
pygame.display.set_icon(pygame.image.load('images/other/icon.png'))

buttonimage=pygame.image.load('images/other/button.png')
buttonpressed=pygame.image.load('images/other/buttonpressed.png')
buttonhighlighted=pygame.image.load('images/other/buttonhighlighted.png')

coin=pygame.image.load('images/other/coin.png')
coin=pygame.transform.scale(coin, (34, 34))
coin.set_colorkey((255,255,255))

coinicon=pygame.image.load('images/other/coinicon.png')
coinicon=pygame.transform.scale(coinicon, (34, 34))
coinicon.set_colorkey((255,255,255))

title=pygame.image.load('images/other/title.png')
title=pygame.transform.scale(title, (200, 100))
title.set_colorkey((255,255,255))

#set up music
pygame.mixer.music.load('music/sprinkler_system.wav')

#set up font
font =pygame.font.SysFont(None, 40)
	 	
	 	
#define levels
worlds=['world1', 'world2', 'world3', 'world4', 'world5']
world_coins=[3, 4, 5, 6, 0]	 
#world_coins=[0, 0, 0, 0, 0]	

#game
def main():
	global main_game	 		 		
	main_game=game()
		
	while True:
		main_game.loop()	
		
#a=monologue('mappieces/standard')	

heading()	
pygame.mixer.music.play(-1, 0.0)
main()		

